!  
!  ****  Search value of pi by monte-carlo method  ****
!
   program pi_monte

      implicit none

      real(8):: pi, pitrue, diffpi
      real(8):: x, y, y_x
      integer:: nmax, i, np, ip

      pitrue = 4.0d0 * atan( 1.0d0 )

      write ( 6,* ) 'Input number of trials'
      read ( 5,* ) nmax

!  ****  open file  ****

      open ( 10, file='xy.dat' )
      open ( 11, file='pi.dat' )

      call ranseed( )

      np = 0

!  ****  Loop of trials  ***************************************************************

      do i = 1, nmax

        ip = 0

        call random_number( x )
        call random_number( y )

        y_x = sqrt( 1.0d0 - x**2 )

!  ***  case when y < sqrt( 1.0d0 - x**2 )  ****

        if ( y < y_x ) then
          np = np + 1
          ip = 1
        end if

!  **** Calculate pi  ****

        pi = 4.0d0 * dfloat( np ) / dfloat( i )
        diffpi = pi - pitrue

        write ( 10,* ) x,y,ip
        write ( 11,* ) i, pi, pitrue

      end do

      close ( 10 )
      close ( 11 )

!  ****  End of loop  *****************************************************************

      stop

    end program pi_monte

